SystemOrganization addCategory: #'Volunti-RegistrationOffice-Model'!
SystemOrganization addCategory: #'Volunti-RegistrationOffice-View'!

WATask subclass: #VORegistrationTask
	instanceVariableNames: 'authority user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-RegistrationOffice-View'!

!VORegistrationTask class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 7/27/2012 08:05'!
for: anAuthority
	^ self new authority: anAuthority! !

!VORegistrationTask methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 7/27/2012 08:04'!
authority
	^ authority! !

!VORegistrationTask methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 7/27/2012 08:04'!
authority: anAuthority
	authority := anAuthority! !

!VORegistrationTask methodsFor: 'task' stamp: 'NicolasVanderAuwera 7/27/2012 08:41'!
confirmRegistration
	| file |
	file := self createConfirmationFile.
	self call: (VORegistrationConfirmation file: file)! !

!VORegistrationTask methodsFor: 'task' stamp: 'NicolasVanderAuwera 8/3/2012 13:15'!
createConfirmationFile
	^ WAFile new
		contentType: WAMimeType textPlain;
		contents: (VORegistrationOfficeManager current sign: user nationalNumber) greaseString;
		fileName: user lastname translateToLowercase , '-registration_confirmation'! !

!VORegistrationTask methodsFor: 'task' stamp: 'NicolasVanderAuwera 7/27/2012 08:31'!
createDigipass
	self assert: user notNil.
	^ authority digipassFor: user! !

!VORegistrationTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 7/27/2012 08:32'!
go
	| digipass |
	user := self authority addUser: (self call: VORegistratedUserView new).
	digipass := self createDigipass.
	digipass := self call: (VOInitializeDigipassView model: digipass).
	self submitDigipass: digipass.
	self confirmRegistration! !

!VORegistrationTask methodsFor: 'task' stamp: 'NicolasVanderAuwera 2/18/2012 10:26'!
submitDigipass: aDigipass
	VODigipass addDigipass: aDigipass! !

VOAgentComponent subclass: #VORegistrationView
	instanceVariableNames: 'office'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-RegistrationOffice-View'!

!VORegistrationView class methodsFor: 'class initialization' stamp: 'NicolasVanderAuwera 5/5/2012 07:28'!
initialize
	super initialize.
	self register! !

!VORegistrationView class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/23/2012 10:08'!
url
	^ 'registrationoffice'! !

!VORegistrationView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 7/23/2012 07:40'!
agentClass
	^ VORegistrationOfficeManager! !

!VORegistrationView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/23/2012 10:22'!
main
	^ VORegistrationMainAreaView! !

!VORegistrationView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/23/2012 10:09'!
title
	^ 'Registration Office'! !

VOMainAreaComponent subclass: #VORegistrationMainAreaView
	instanceVariableNames: 'registrationOfficeListView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-RegistrationOffice-View'!

!VORegistrationMainAreaView methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 5/3/2012 11:15'!
children
	^ Array with: self registrationOfficeListView! !

!VORegistrationMainAreaView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 7/23/2012 07:49'!
registrationOfficeListView
	registrationOfficeListView
		ifNil: [ registrationOfficeListView := VORegistrationOfficeList elections: self agent authorities ].
	^ registrationOfficeListView! !

!VORegistrationMainAreaView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/22/2012 13:41'!
renderMainContentOn: html
	super renderMainContentOn: html.
	html render: self registrationOfficeListView! !

WAComponent subclass: #VORegistrationConfirmation
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-RegistrationOffice-View'!

!VORegistrationConfirmation class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 7/27/2012 08:29'!
file: aWAFile
	^ self new file: aWAFile! !

!VORegistrationConfirmation methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/18/2012 07:56'!
downloadFile
	self requestContext
		respond: [ :response | 
			response
				contentType: 'text/xml';
				document: file rawContents greaseString;
				attachmentWithFileName: file fileName ]! !

!VORegistrationConfirmation methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 7/27/2012 08:28'!
file: aWAFile
	file := aWAFile! !

!VORegistrationConfirmation methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/20/2012 06:45'!
renderContentOn: html
	html paragraph
		class: 'info';
		with: 'You have been properly registered !!'.
	html paragraph
		class: 'notice';
		with: [ 
					html text: 'Here is your '.
					html anchor
						callback: [ self downloadFile ];
						with: 'registration information'.
					html text: '.' ]! !

!VORegistrationConfirmation methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/29/2012 12:15'!
renderDownloadButtonOn: html
	html anchor
		callback: [ self downloadFile ];
		with: 'Download'! !

WAComponent subclass: #VOShowIdView
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-RegistrationOffice-View'!

!VOShowIdView class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 2/7/2012 07:04'!
identifier: anId
	^ self new id: anId! !

!VOShowIdView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/7/2012 07:06'!
id
	^ id! !

!VOShowIdView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/7/2012 07:06'!
id: anObject
	id := anObject! !

!VOShowIdView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/18/2012 08:51'!
renderAnchorContinueOn: html
	html anchor
		callback: [ self answer ];
		with: 'Continue'! !

!VOShowIdView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/18/2012 08:51'!
renderContentOn: html
	self renderIdOn: html.
	self renderAnchorContinueOn: html! !

!VOShowIdView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/7/2012 07:10'!
renderIdOn: html
	html paragraph
		class: 'info';
		with: [ 
					html text: 'Your identifier is '.
					html strong: self id ]! !

WAComponent subclass: #VOUsersList
	instanceVariableNames: 'users report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-RegistrationOffice-View'!

!VOUsersList class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 5/16/2012 19:58'!
users: aCollection
	^ self new users: aCollection! !

!VOUsersList methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 8/2/2012 14:38'!
initializeReport
	report := (WATableReport new)
		rows: users asOrderedCollection;
		columns:
				((OrderedCollection new)
						add: (WAReportColumn selector: #firstname title: 'Firstname');
						add: (WAReportColumn selector: #lastname title: 'Lastname');
						add: (WAReportColumn selector: #nationalNumber title: 'National Number');
						yourself);
		rowColors: #(#lightblue #lightyellow);
		rowPeriod: 1;
		yourself! !

!VOUsersList methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/16/2012 20:18'!
renderBackAnchorOn: html
	(html anchor)
		callback: [ self answer ];
		with: 'Back'! !

!VOUsersList methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/16/2012 20:18'!
renderContentOn: html
	html render: self report.
	self renderBackAnchorOn: html! !

!VOUsersList methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/16/2012 20:04'!
report
	report ifNil: [ self initializeReport ].
	^ report! !

!VOUsersList methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/16/2012 19:58'!
users: aCollection
	users := aCollection! !

WALabelledFormDialog subclass: #VOInitializeDigipassView
	instanceVariableNames: 'digipass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-RegistrationOffice-View'!

!VOInitializeDigipassView class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 2/18/2012 08:43'!
model: aDigipass
	^ self new model: aDigipass! !

!VOInitializeDigipassView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/18/2012 08:41'!
buttons
	^ #(#initialization)! !

!VOInitializeDigipassView methodsFor: 'actions' stamp: 'NicolasVanderAuwera 2/18/2012 08:41'!
initialization
	self answer: self model! !

!VOInitializeDigipassView methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 2/18/2012 08:50'!
initialize
	super initialize.
	self validateWith: [ :aDigipass | aDigipass validate ].
	self addMessage: 'Initialization of your digipass'! !

!VOInitializeDigipassView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/18/2012 08:42'!
model
	^ digipass! !

!VOInitializeDigipassView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/18/2012 08:47'!
model: aDigipass
	digipass := aDigipass! !

!VOInitializeDigipassView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/3/2012 16:09'!
renderConfirmationPinOn: html
	html passwordInput callback: [ :value | self model confirmationPin: value greaseInteger ]! !

!VOInitializeDigipassView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/3/2012 16:09'!
renderPinOn: html
	html passwordInput callback: [ :value | self model pin: value greaseInteger ]! !

!VOInitializeDigipassView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 16:03'!
rows
	^ #(#pin #confirmationPin)! !

WALabelledFormDialog subclass: #VORegistratedUserView
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-RegistrationOffice-View'!

!VORegistratedUserView methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 2/6/2012 10:28'!
initialize
	super initialize.
	self validateWith: [ :aUser | aUser validate ].
	model := VORegistratedUser new! !

!VORegistratedUserView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/6/2012 10:27'!
model
	^ model! !

!VORegistratedUserView methodsFor: 'actions' stamp: 'NicolasVanderAuwera 2/6/2012 10:19'!
ok
	^ self answer: model! !

!VORegistratedUserView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/3/2012 11:09'!
renderAgeOn: html
	html select
		list: (18 to: 150);
		callback: [ :value | model age: value greaseInteger ]! !

!VORegistratedUserView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 11:10'!
rows
	^ model fields! !

VOAuthority subclass: #VORegistrationOffice
	instanceVariableNames: 'users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-RegistrationOffice-Model'!

VORegistrationOffice subclass: #VOCompleteRegistrationOffice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-RegistrationOffice-Model'!

!VOCompleteRegistrationOffice methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/16/2012 20:09'!
digipassFor: aUser
	| socketStream sk pk cert kgs |
	kgs := self configurations at: VOKeyGenerationServer key.
	socketStream := SocketStream openConnectionToHostNamed: kgs host port: kgs port.
	socketStream sendCommand: 'keys'.
	pk := socketStream receiveObject.
	sk := socketStream receiveObject.
	socketStream close.
	cert := self requestCertificate: pk for: aUser.
	self addUser: aUser.
	^ VODigipass certificate: cert rsaSk: sk rsaPk: pk! !

!VOCompleteRegistrationOffice methodsFor: 'testing' stamp: 'NicolasVanderAuwera 8/2/2012 14:19'!
hasUserWithNationalNumber: aString
	^ users anySatisfy: [ :user | (user nationalNumber = aString) ]! !

!VOCompleteRegistrationOffice methodsFor: 'network' stamp: 'NicolasVanderAuwera 10/29/2012 16:33'!
requestCertificate: publicKey for: aUser
	| dataRead clientStream size certificationAuth cert |
	certificationAuth := self configurations at: VOCertificationAuthority key.
	clientStream := SocketStream openConnectionToHostNamed: certificationAuth host port: certificationAuth port.
	clientStream sendCommand: 'certificateOf'.
	clientStream sendObject: aUser asSubjectInfo.
	cert := clientStream receiveObject.
	clientStream close.
	cert
		ifNil: [ 
			clientStream := SocketStream openConnectionToHostNamed: certificationAuth host port: certificationAuth port.
			clientStream sendObject: aUser asSubjectInfo message: 'registration'.
			clientStream sendObject: publicKey.
			cert := clientStream receiveObject.
			clientStream close ].
	^ cert! !

!VORegistrationOffice methodsFor: 'adding' stamp: 'NicolasVanderAuwera 5/3/2012 12:01'!
addUser: aUser
	^ users add: aUser! !

!VORegistrationOffice methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 5/3/2012 06:26'!
initialize
	super initialize.
	users := Set new! !

!VORegistrationOffice methodsFor: 'searching' stamp: 'NicolasVanderAuwera 5/3/2012 06:41'!
userWith: aString
	^ users detect: [ :each | each name = aString ] ifNone: [ nil ]! !

!VORegistrationOffice methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/16/2012 20:08'!
users
	^ users! !

VORegistrationOffice subclass: #VOSimpleRegistrationOffice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-RegistrationOffice-Model'!

!VOSimpleRegistrationOffice methodsFor: 'searching' stamp: 'NicolasVanderAuwera 5/3/2012 06:45'!
userWithName: aString password: anotherString
	^ self users detect: [ :each | each name = aString and: [ each verifyPassword: anotherString ] ] ifNone: [ nil ]! !

VOElectionsListComponent subclass: #VORegistrationOfficeList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-RegistrationOffice-View'!

!VORegistrationOfficeList methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/3/2012 06:01'!
renderAnchorRegistrateFor: election on: html
	html anchor
		callback: [ self call: (VORegistrationTask for: election) ];
		with: 'Registrate'! !

!VORegistrationOfficeList methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/16/2012 20:07'!
renderAnchorUsersFor: election on: html
	(html anchor)
		callback: [ self call: (VOUsersList users: election users) ];
		with: 'Registrated Users'! !

!VORegistrationOfficeList methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/16/2012 20:07'!
renderMoreData: election on: html
	html
		tableData: [ 
			self renderAnchorRegistrateFor: election on: html.
			self session isManager
				ifTrue: [ 
					html text: ' | '.
					self renderAnchorUsersFor: election on: html ] ]! !

!VORegistrationOfficeList methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/3/2012 06:02'!
renderMoreDataHeadingOn: html
	html tableHeading: 'Action'! !

!VORegistrationOfficeList methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/7/2012 07:03'!
renderTableBodyOn: html
	self elections
		do: [ :election | 
			election opened
				ifFalse: [ self renderElection: election on: html ] ]! !

VOManager subclass: #VORegistrationOfficeManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-RegistrationOffice-Model'!

VORegistrationOfficeManager class
	instanceVariableNames: 'ids'!

VORegistrationOfficeManager class
	instanceVariableNames: 'ids'!

!VORegistrationOfficeManager class methodsFor: 'x509' stamp: 'NicolasVanderAuwera 5/5/2012 13:42'!
organisationUnit
	^ 'Registration Office'! !

!VORegistrationOfficeManager methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 7/23/2012 07:48'!
authentication
	| aUser subAgent |
	subAgent := self authorityWithId: stream nextLine greaseInteger.
	aUser := stream receiveObject.
	(subAgent userWithID: aUser name password: aUser password) isNil
		ifFalse: [ stream sendCommand: #success ]
		ifTrue: [ stream sendCommand: #error ]! !

!VORegistrationOfficeManager methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/19/2012 09:02'!
authorityClass
	^ VORegistrationOffice! !

!VORegistrationOfficeManager methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 7/23/2012 09:08'!
authorityFor: aProtocol
	aProtocol = #anonymous
		ifTrue: [ ^ VOSimpleRegistrationOffice ].
	^ VOCompleteRegistrationOffice! !

!VORegistrationOfficeManager methodsFor: 'network' stamp: 'NicolasVanderAuwera 5/11/2012 07:38'!
handle: aSymbol
	super handle: aSymbol.
	aSymbol = #verification
		ifTrue: [ self verifyUser ].
	aSymbol = #authenticate
		ifFalse: [ ^ self ].
	self authentication! !

!VORegistrationOfficeManager methodsFor: 'testing' stamp: 'NicolasVanderAuwera 8/2/2012 14:20'!
verifyUser
	(self authorityOnStream hasUserWithNationalNumber: stream nextLine)
		ifTrue: [ stream sendCommand: 'success' ]
		ifFalse: [ stream sendCommand: 'error' ]! !
VORegistrationView initialize!
